/* MailTweak internal component - Copyright (C) 2007 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/mailtweak.html */
function NSGetModule(compMgr, fileSpec) {
return mailtweakModule}
var mailtweakModule = {
CID: Components.ID("{c641b73e-114f-b5b5-5eec-ec6cc00146ee}"),contractID: "@rod.whiteley/mailtweak;1",className: "MailTweak",registerSelf: function (mgr, file, loc, type) {
mgr.QueryInterface(Components.interfaces.nsIComponentRegistrar).registerFactoryLocation(this.CID, this.className, this.contractID, file, loc, type)
Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager).addCategoryEntry("app-startup", this.className, "service," + this.contractID, true, true, null)},getClassObject: function (aComponentManager, aCID, aIID) {
if (!aIID.equals(Components.interfaces.nsIFactory))
throw Components.results.NS_ERROR_NOT_IMPLEMENTED
if (!aCID.equals(this.CID))
throw Components.results.NS_ERROR_NO_INTERFACE
return this.factory},factory: {
createInstance: function (aOuter, aIID) {
if (aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION
return MailTweakService}},canUnload: function () {return true}}
MailTweakService = {
obs: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),pref: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),prefBranch: null,_onetime: false,_cleanup: [],about: function (wdw, evt) {
var v0 = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).getItemForID("mail-tweak@rod.whiteley").version
this._about = (this.prefBranch.getCharPref("version") != v0)
if (this._about) {
this.prefBranch.setCharPref("version", v0)
this._options = false
wdw.openDialog(
"chrome://mailtweak/content/about.xul","_blank","chrome,modal,centerscreen",this)
if (this._options) wdw.openDialog(
"chrome://mailtweak/content/options.xul","_blank","chrome,modal,centerscreen",null)}},_appliedURI: null,applyStyle: function () {
if (this._appliedURI) {
Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService).unregisterSheet(this._appliedURI, 0)
this._appliedURI = null}
var css = ""
if (this.prefBranch.getBoolPref("treefont")) {
var size = this.prefBranch.getIntPref("treefont.size")
if (size) css += "treechildren%7Bfont-size%3A" + String(size) + "px%3B%7D"}
if (css) {
this._appliedURI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI("data:text/css," + css, "", null)
Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService).loadAndRegisterSheet(this._appliedURI, 0)}},observe: function (subject, topic, data) {
switch (topic) {
case "app-startup":
this.obs.addObserver(this, "domwindowopened", false)
this.obs.addObserver(this, "em-action-requested", false)
break;
case "domwindowopened":
subject.MailTweakService = this
if (this._onetime) return
else this._onetime = true
var pf = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("PrefD", Components.interfaces.nsIFile)
pf.append("prefs.js")
this.pref.readUserPrefs(pf)
this.prefBranch = this.pref.getBranch("extension.mailtweak.")
this.applyStyle()
var self = this
var focus = function (event) {
event.target.removeEventListener("focus", focus, false)
self.about(subject, event)}
subject.addEventListener("load",function (event) {
var tt = event.target.getElementById("threadTree")
if (!tt) return
tt.addEventListener("focus", focus, false)},false)
break;
case "em-action-requested":
var item = subject.QueryInterface(Components.interfaces.nsIUpdateItem)
if (item.id != "mail-tweak@rod.whiteley") return
switch (data) {
case "item-disabled":
this._prefCache = null
case "item-uninstalled":
this._prefCache = []
var b = this.prefBranch
var cc = b.getChildList("", {})
for each (var c in cc) {
var t = b.getPrefType(c)
var v = (t == 32)? b.getCharPref(c) : (t == 64)? b.getIntPref(c) : b.getBoolPref(c)
this._prefCache.push({name: c, type: t, value: v})}
b.deleteBranch("")
break;
case "item-cancel-action":
if (!this._prefCache) return
var b = this.prefBranch
for each (var c in this._prefCache) {
if (c.type == 32) b.setCharPref(c.name, c.value)
else if (c.type == 64) b.setIntPref(c.name, c.value)
else b.setBoolPref(c.name, c.value)}
this._prefCache = null
break;}
break;}},reload: function (doMail, doAB, doComp) {
this.applyStyle()
var WW = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher)
var a = []
if (doMail) a.push({type: "mail:3pane", url: "chrome://messenger/content/messenger.xul"})
if (doAB) a.push({type: "mail:addressbook", url: "chrome://messenger/content/addressbook/addressbook.xul"})
if (doComp) a.push({type: "msgcompose", url: null})
for each (var spec in a) {
var enum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getEnumerator(spec.type)
while (enum.hasMoreElements()) {
const feat = "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar"
var w = enum.getNext()
if (spec.url && !enum.hasMoreElements())
WW.openWindow(null, spec.url, "_blank", feat, null )
w.close()}}},toString: function () {
return "[object MailTweakService]"}}
